#include "../VertexShader.h"

// _VF[_[̓
struct VS_INPUT
{
	float3 Position        : POSITION ;			// W( [J )
	float3 Normal          : NORMAL ;			// @( [J )
	float4 Diffuse         : COLOR0 ;			// fBt[YJ[
	float4 Specular        : COLOR1 ;			// XyLJ[
	float4 TexCoords0      : TEXCOORD0 ;		// eNX`W
	float4 TexCoords1      : TEXCOORD1 ;		// TueNX`W

#if BUMPMAP || BUMPMAP_VERTEXDATAONLY
	// ov}bv
	float3 Tan             : TANGENT0 ;			// ڐ( [J )
	float3 Bin             : BINORMAL0 ;		// ]@( [J )
#endif // BUMPMAP

#ifdef SKINMESH
	// XLjObV
	int4   BlendIndices0   : BLENDINDICES0 ;	// {[p Float^萔zCfbNXO
	float4 BlendWeight0    : BLENDWEIGHT0 ;		// {[pEGCglO

	#ifdef BONE8

		int4   BlendIndices1   : BLENDINDICES1 ;	// {[p Float^萔zCfbNXP
		float4 BlendWeight1    : BLENDWEIGHT1 ;		// {[pEGCglP

	#endif // BONE8

#endif // SKINMESH
} ;

// _VF[_[̏o
struct VS_OUTPUT
{
	float4 Diffuse         : COLOR0 ;		// fBt[YJ[
	float4 Specular        : COLOR1 ;		// XyLJ[
	float4 TexCoords0_1    : TEXCOORD0 ;	// eNX`WƃTueNX`W( x:eNX`Wx  y:eNX`Wy  z:TueNX`Wx  w:TueNX`Wy )

	float3 V_to_Eye        : TEXCOORD1 ;	// _W王ւ̃xNg( r[ )
	float4 Normal_Fog      : TEXCOORD2 ;	// x.y.z:@( r[ )  w:tHOp[^

#if LG0_USE
	float4 Light0_Dir_Gen  : TEXCOORD3 ;	// xyz:CgŐtxNg( r[ ) w:CgO
#endif
#if LG1_USE
	float4 Light1_Dir_Gen  : TEXCOORD4 ;	// xyz:CgP̋txNg( r[ ) w:CgP
#endif
#if LG2_USE
	float4 Light2_Dir_Gen  : TEXCOORD5 ;	// xyz:CgQ̋txNg( r[ ) w:CgQ
#endif

#if SHADOWMAP || SHADOWMAP_DRAW
	float3 ShadowMap0Pos   : TEXCOORD6 ;	// VhE}bvÕCgW( x, y, z )
#endif
#if SHADOWMAP
	float3 ShadowMap1Pos   : TEXCOORD7 ;	// VhE}bvP̃CgW( x, y, z )
	float3 ShadowMap2Pos   : TEXCOORD8 ;	// VhE}bvQ̃CgW( x, y, z )
#endif
	float4 Position        : SV_POSITION ;	// W( vWFNV )
} ;

#ifdef SKINMESH
#define LOCAL_WORLD_MAT         lLocalWorldMatrix
#else
#define LOCAL_WORLD_MAT         g_Base.LocalWorldMatrix
#endif

#define FOG_OUT                 VSOutput.Normal_Fog.w

// main֐
VS_OUTPUT main( VS_INPUT VSInput )
{
	VS_OUTPUT	VSOutput ;
	int4		lBoneFloatIndex ;
	float4		lLocalWorldMatrix[ 3 ] ;
	float4		lLocalPosition ;
	float4		lWorldPosition ;
	float4		lViewPosition ;
	float3		lWorldNrm ;
	float3		lWorldTan ;
	float3		lWorldBin ;
	float3		lViewNrm ;
	float3		lViewTan ;
	float3		lViewBin ;
	float3		lBumpTemp ;
	float4		lTotalDiffuse ;
	float4		lTotalSpecular ;
	float3		lLightDir ;
	float		lTotalGen ;
	float3		lLightTemp ;
	float		lLightDistancePow2 ;
	float		lLightGen ;
	float		lLightDirectionCosA ;
	float3		lLightHalfVec ;
	float4		lLightLitParam ;
	float4		lLightLitDest ;
	float4		lDifColor;
#if USE_SPE
	float4		lSpeColor;
#endif
#if SHADOWMAP
	float4		lLViewPosition ;
#endif

	lDifColor = g_Base.DiffuseSource  > 0.5f ? VSInput.Diffuse  : g_Common.Material.Diffuse ;
	
#if USE_SPE
	lSpeColor = ( g_Base.SpecularSource > 0.5f ? VSInput.Specular : g_Common.Material.Specular ) * g_Base.MulSpecularColor ;
#endif

	VSOutput.V_to_Eye   = float3( 0.0f, 0.0f, 0.0f ) ;
	VSOutput.Specular   = float4( 0.0f, 0.0f, 0.0f, 0.0f ) ;
	VSOutput.Normal_Fog = float4( 0.0f, 0.0f, 0.0f, 1.0f ) ;

	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	#ifdef SKINMESH

		// XLbV

		// uhs̍쐬
		lBoneFloatIndex = VSInput.BlendIndices0 ;
		lLocalWorldMatrix[ 0 ]  = g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.x + 0 ] * VSInput.BlendWeight0.xxxx;
		lLocalWorldMatrix[ 1 ]  = g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.x + 1 ] * VSInput.BlendWeight0.xxxx;
		lLocalWorldMatrix[ 2 ]  = g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.x + 2 ] * VSInput.BlendWeight0.xxxx;

		lLocalWorldMatrix[ 0 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.y + 0 ] * VSInput.BlendWeight0.yyyy;
		lLocalWorldMatrix[ 1 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.y + 1 ] * VSInput.BlendWeight0.yyyy;
		lLocalWorldMatrix[ 2 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.y + 2 ] * VSInput.BlendWeight0.yyyy;

		lLocalWorldMatrix[ 0 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.z + 0 ] * VSInput.BlendWeight0.zzzz;
		lLocalWorldMatrix[ 1 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.z + 1 ] * VSInput.BlendWeight0.zzzz;
		lLocalWorldMatrix[ 2 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.z + 2 ] * VSInput.BlendWeight0.zzzz;

		lLocalWorldMatrix[ 0 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.w + 0 ] * VSInput.BlendWeight0.wwww;
		lLocalWorldMatrix[ 1 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.w + 1 ] * VSInput.BlendWeight0.wwww;
		lLocalWorldMatrix[ 2 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.w + 2 ] * VSInput.BlendWeight0.wwww;

		#ifdef BONE8

			lBoneFloatIndex = VSInput.BlendIndices1 ;
			lLocalWorldMatrix[ 0 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.x + 0 ] * VSInput.BlendWeight1.xxxx;
			lLocalWorldMatrix[ 1 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.x + 1 ] * VSInput.BlendWeight1.xxxx;
			lLocalWorldMatrix[ 2 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.x + 2 ] * VSInput.BlendWeight1.xxxx;

			lLocalWorldMatrix[ 0 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.y + 0 ] * VSInput.BlendWeight1.yyyy;
			lLocalWorldMatrix[ 1 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.y + 1 ] * VSInput.BlendWeight1.yyyy;
			lLocalWorldMatrix[ 2 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.y + 2 ] * VSInput.BlendWeight1.yyyy;

			lLocalWorldMatrix[ 0 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.z + 0 ] * VSInput.BlendWeight1.zzzz;
			lLocalWorldMatrix[ 1 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.z + 1 ] * VSInput.BlendWeight1.zzzz;
			lLocalWorldMatrix[ 2 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.z + 2 ] * VSInput.BlendWeight1.zzzz;

			lLocalWorldMatrix[ 0 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.w + 0 ] * VSInput.BlendWeight1.wwww;
			lLocalWorldMatrix[ 1 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.w + 1 ] * VSInput.BlendWeight1.wwww;
			lLocalWorldMatrix[ 2 ] += g_LocalWorldMatrix.Matrix[ lBoneFloatIndex.w + 2 ] * VSInput.BlendWeight1.wwww;

		#endif // BONE8

	#endif	// SKINMESH

	// [JW̃Zbg
	lLocalPosition.xyz = VSInput.Position ;
	lLocalPosition.w = 1.0f ;

	#ifdef TOONOUTLINE

		// WvZ( [J[h )
		lWorldPosition.x = dot( lLocalPosition, LOCAL_WORLD_MAT[ 0 ] ) ;
		lWorldPosition.y = dot( lLocalPosition, LOCAL_WORLD_MAT[ 1 ] ) ;
		lWorldPosition.z = dot( lLocalPosition, LOCAL_WORLD_MAT[ 2 ] ) ;
		lWorldPosition.w = 1.0f ;

		lWorldNrm.x = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 0 ].xyz ) ;
		lWorldNrm.y = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 1 ].xyz ) ;
		lWorldNrm.z = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 2 ].xyz ) ;

		// ֊s̑@Ɉړ
		lWorldPosition.xyz += lWorldNrm * g_Base.ToonOutLineSize.x ;

		// [hr[
		lViewPosition.x = dot( lWorldPosition, g_Base.ViewMatrix[ 0 ] ) ;
		lViewPosition.y = dot( lWorldPosition, g_Base.ViewMatrix[ 1 ] ) ;
		lViewPosition.z = dot( lWorldPosition, g_Base.ViewMatrix[ 2 ] ) ;
		lViewPosition.w = 1.0f ;

		// r[vWFNV
		VSOutput.Position.x = dot( lViewPosition, g_Base.ProjectionMatrix[ 0 ] ) ;
		VSOutput.Position.y = dot( lViewPosition, g_Base.ProjectionMatrix[ 1 ] ) ;
		VSOutput.Position.z = dot( lViewPosition, g_Base.ProjectionMatrix[ 2 ] ) ;
		VSOutput.Position.w = dot( lViewPosition, g_Base.ProjectionMatrix[ 3 ] ) ;

	#else  // TOONOUTLINE

		// WvZ( [Jr[vWFNV )
		lWorldPosition.x = dot( lLocalPosition, LOCAL_WORLD_MAT[ 0 ] ) ;
		lWorldPosition.y = dot( lLocalPosition, LOCAL_WORLD_MAT[ 1 ] ) ;
		lWorldPosition.z = dot( lLocalPosition, LOCAL_WORLD_MAT[ 2 ] ) ;
		lWorldPosition.w = 1.0f ;

		lViewPosition.x = dot( lWorldPosition, g_Base.ViewMatrix[ 0 ] ) ;
		lViewPosition.y = dot( lWorldPosition, g_Base.ViewMatrix[ 1 ] ) ;
		lViewPosition.z = dot( lWorldPosition, g_Base.ViewMatrix[ 2 ] ) ;
		lViewPosition.w = 1.0f ;

		VSOutput.Position.x = dot( lViewPosition, g_Base.ProjectionMatrix[ 0 ] ) ;
		VSOutput.Position.y = dot( lViewPosition, g_Base.ProjectionMatrix[ 1 ] ) ;
		VSOutput.Position.z = dot( lViewPosition, g_Base.ProjectionMatrix[ 2 ] ) ;
		VSOutput.Position.w = dot( lViewPosition, g_Base.ProjectionMatrix[ 3 ] ) ;

	#endif // TOONOUTLINE

	#ifdef BUMPMAP

		// ]@AڐA@r[Ԃɓe
		lWorldTan.x = dot( VSInput.Tan, LOCAL_WORLD_MAT[ 0 ].xyz ) ;
		lWorldTan.y = dot( VSInput.Tan, LOCAL_WORLD_MAT[ 1 ].xyz ) ;
		lWorldTan.z = dot( VSInput.Tan, LOCAL_WORLD_MAT[ 2 ].xyz ) ;

		lWorldBin.x = dot( VSInput.Bin, LOCAL_WORLD_MAT[ 0 ].xyz ) ;
		lWorldBin.y = dot( VSInput.Bin, LOCAL_WORLD_MAT[ 1 ].xyz ) ;
		lWorldBin.z = dot( VSInput.Bin, LOCAL_WORLD_MAT[ 2 ].xyz ) ;

		lWorldNrm.x = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 0 ].xyz ) ;
		lWorldNrm.y = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 1 ].xyz ) ;
		lWorldNrm.z = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 2 ].xyz ) ;

		lViewTan.x = dot( lWorldTan, g_Base.ViewMatrix[ 0 ].xyz ) ;
		lViewTan.y = dot( lWorldTan, g_Base.ViewMatrix[ 1 ].xyz ) ;
		lViewTan.z = dot( lWorldTan, g_Base.ViewMatrix[ 2 ].xyz ) ;

		lViewBin.x = dot( lWorldBin, g_Base.ViewMatrix[ 0 ].xyz ) ;
		lViewBin.y = dot( lWorldBin, g_Base.ViewMatrix[ 1 ].xyz ) ;
		lViewBin.z = dot( lWorldBin, g_Base.ViewMatrix[ 2 ].xyz ) ;

		lViewNrm.x = dot( lWorldNrm, g_Base.ViewMatrix[ 0 ].xyz ) ;
		lViewNrm.y = dot( lWorldNrm, g_Base.ViewMatrix[ 1 ].xyz ) ;
		lViewNrm.z = dot( lWorldNrm, g_Base.ViewMatrix[ 2 ].xyz ) ;

	#endif	// BUMPMAP


	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )

	#if LG_USE == 0 || BUMPMAP == 1 || PHONG == 1

		// CggpȂAov}bv̓tHVF[fBȌꍇ̓}eA( or _ )J[̂܂܏o
		VSOutput.Diffuse  = lDifColor ;

		#if USE_SPE
			VSOutput.Specular = lSpeColor ;
		#endif
		
		#if BUMPMAP == 0 && PHONG
		
			// @r[Ԃ̊pxɕϊ( LOCAL_WORLD_MAT ̓XLjObV ̏ꍇ r0 ĝ mov r0, 0.0f ɎsKv )
			lWorldNrm.x = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 0 ].xyz ) ;
			lWorldNrm.y = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 1 ].xyz ) ;
			lWorldNrm.z = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 2 ].xyz ) ;

			lViewNrm.x = dot( lWorldNrm, g_Base.ViewMatrix[ 0 ].xyz ) ;
			lViewNrm.y = dot( lWorldNrm, g_Base.ViewMatrix[ 1 ].xyz ) ;
			lViewNrm.z = dot( lWorldNrm, g_Base.ViewMatrix[ 2 ].xyz ) ;

			// @ۑ
			VSOutput.Normal_Fog.xyz = lViewNrm ;

		#endif // PHONG

	#endif // LG_USE == 0 || BUMPMAP == 1 || PHONG == 1





	// Cg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )
	#if LG_USE

		#ifdef BUMPMAP

			#if USE_SPE
				// _W王_ւ̃xNgڒԂɓe㐳Kĕۑ
				lBumpTemp.x = dot( lViewTan, -lViewPosition.xyz ) ;
				lBumpTemp.y = dot( lViewBin, -lViewPosition.xyz ) ;
				lBumpTemp.z = dot( lViewNrm, -lViewPosition.xyz ) ;
				VSOutput.V_to_Eye = normalize( lBumpTemp ) ;
			#endif

		#else // BUMPMAP 

			// @r[Ԃ̊pxɕϊ( LOCAL_WORLD_MAT ̓XLjObV ̏ꍇ r0 ĝ mov r0, 0.0f ɎsKv )
			lWorldNrm.x = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 0 ].xyz ) ;
			lWorldNrm.y = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 1 ].xyz ) ;
			lWorldNrm.z = dot( VSInput.Normal, LOCAL_WORLD_MAT[ 2 ].xyz ) ;

			lViewNrm.x = dot( lWorldNrm, g_Base.ViewMatrix[ 0 ].xyz ) ;
			lViewNrm.y = dot( lWorldNrm, g_Base.ViewMatrix[ 1 ].xyz ) ;
			lViewNrm.z = dot( lWorldNrm, g_Base.ViewMatrix[ 2 ].xyz ) ;

			// fBt[YJ[ƃXyLJ[̒~ϒl̏
			lTotalDiffuse  = float4( 0, 0, 0, 0 ) ;
			lTotalSpecular = float4( 0, 0, 0, 0 ) ;

			#ifdef PHONG

				#if USE_SPE
					// _W王_ւ̃xNg𐳋Kĕۑ
					VSOutput.V_to_Eye = normalize( -lViewPosition.xyz ) ;
				#endif

				// @ۑ
				VSOutput.Normal_Fog.xyz = lViewNrm ;

			#endif // PHONG

		#endif // BUMPMAP







		// Cg0̏ ***********************************************************************************************************************************( Jn )
#if LG0_USE

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( Jn )

	#if LG0_DIR

		// Cg̕vZ
		lLightDir = g_Common.Light[ 0 ].Direction ;

	#else  // LG0_DIR

		// CgxNǧvZ
		lLightDir = normalize( lViewPosition.xyz - g_Common.Light[ 0 ].Position ) ;

	#endif  // LG0_DIR

	// Cg̏
	VSOutput.Light0_Dir_Gen = 0.0f ;

	// Cǧ̋txNgڒnԂɕϊ
	#ifdef BUMPMAP

		lLightTemp.x = dot( lViewTan, -lLightDir ) ;
		lLightTemp.y = dot( lViewBin, -lLightDir ) ;
		lLightTemp.z = dot( lViewNrm, -lLightDir ) ;
		VSOutput.Light0_Dir_Gen.xyz = normalize( lLightTemp ) ;

	#elif PHONG // BUMPMAP

		// Cǧ̋txNgۑ
		VSOutput.Light0_Dir_Gen.xyz = -lLightDir ;

	#endif // BUMPMAP

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( I )


	// EX|bgCglvZ ==========================( Jn )
	#if LG0_SPOT || LG0_POINT

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂ lLightTemp.x = ( POS - L0_POS ) * ( POS - L0_POS )
		lLightTemp = lViewPosition.xyz - g_Common.Light[ 0 ].Position ;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = 1.0f / ( g_Common.Light[ 0 ].Attenuation0 + g_Common.Light[ 0 ].Attenuation1 * sqrt( lLightDistancePow2 ) + g_Common.Light[ 0 ].Attenuation2 * lLightDistancePow2 ) ;

		// X|bgCgvZ --------

		#if LG0_SPOT

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, g_Common.Light[ 0 ].Direction.xyz ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - g_Common.Light[ 0 ].SpotParam0, 0.0f ) * g_Common.Light[ 0 ].SpotParam1 ), g_Common.Light[ 0 ].FallOff ) ) ;

		#endif // LG0_SPOT

		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, g_Common.Light[ 0 ].RangePow2 ) ;

		// ov}bv or tHVF[fBOpɌۑ
		#if PHONG || BUMPMAP
			VSOutput.Light0_Dir_Gen.w = lLightGen ;
		#endif // PHONG || BUMPMAP

	#endif // LG0_SPOT || LG0_POINT
	// EX|bgCglvZ =========================( I )




	// fBt[YCgƃXyLCg̊pxvZ =======( Jn )
	#if BUMPMAP == 0 && PHONG == 0

		// @ƃCg̋txNgƂ̓ς lLightLitParam.x ɃZbg
		lLightLitParam.x = dot( lViewNrm, -lLightDir ) ;

		#ifdef USE_SPE

			// n[txNǧvZ norm( ( norm( _ʒu王_ւ̃xNg ) + Cg̕ ) )
			lLightHalfVec = normalize( normalize( -lViewPosition.xyz ) - lLightDir ) ;

			// @ƃn[txNg̓ς lLightLitParam.y ɃZbg
			lLightLitParam.y = dot( lLightHalfVec, lViewNrm ) ;

			// XyL˗ lLightLitParam.w ɃZbg
			lLightLitParam.w = g_Common.Material.Power ;

			// CgvZ
			lLightLitDest = lit( lLightLitParam.x, lLightLitParam.y, lLightLitParam.w ) ;

		#else // USE_SPE

			lLightLitDest.y = max( lLightLitParam.x, 0.0f ) ;

		#endif // USE_SPE

	#endif // BUMPMAP == 0 && PHONG == 0
	// fBt[YCgƃXyLCg̊pxvZ =======( I )





	// fBt[YJ[vZ =======================================( Jn )

	#if BUMPMAP == 0 && PHONG == 0

		#if LG0_SPOT || LG0_POINT

			// fBt[YCg~ϒl += EX|bgCgpxl * ( fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z )
			lTotalDiffuse.xyz += lLightGen * ( lLightLitDest.y * g_Common.Light[ 0 ].Diffuse * lDifColor.xyz + g_Common.Light[ 0 ].Ambient.xyz ) ;

		#else  // LG0_SPOT || LG0_POINT

			// fBt[YCg~ϒl += fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z
			lTotalDiffuse.xyz += lLightLitDest.y * g_Common.Light[ 0 ].Diffuse * lDifColor.xyz + g_Common.Light[ 0 ].Ambient.xyz ;

		#endif // LG0_SPOT || LG0_POINT

	#endif // BUMPMAP == 0 && PHONG == 0

	// fBt[YJ[vZ =======================================( I )





	// XyLJ[vZ =======================================( Jn )

	#ifdef USE_SPE

		#if BUMPMAP == 0 && PHONG == 0

			#if LG0_SPOT || LG0_POINT

				// XyLCg~ϒl += XyLpxvZ * EX|bgCg * Cg̃XyLJ[
				lTotalSpecular.xyz += lLightGen * lLightLitDest.z * g_Common.Light[ 0 ].Specular ;

			#else	// LG0_SPOT || LG0_POINT

				// XyLCg~ϒl += XyLpxvZ * Cg̃XyLJ[
				lTotalSpecular.xyz += lLightLitDest.z * g_Common.Light[ 0 ].Specular ;

			#endif	// LG0_SPOT || LG0_POINT

		#endif // BUMPMAP == 0 && PHONG == 0

	#endif // USE_SPE

	// XyLJ[vZ =======================================( I )




#endif  // LG0_USE
// Cg0̏ ***********************************************************************************************************************************( I )








		// Cg1̏ ***********************************************************************************************************************************( Jn )
#if LG1_USE

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( Jn )

	#if LG1_DIR

		// Cg̕vZ
		lLightDir = g_Common.Light[ 1 ].Direction ;

	#else  // LG1_DIR

		// CgxNǧvZ
		lLightDir = normalize( lViewPosition.xyz - g_Common.Light[ 1 ].Position ) ;

	#endif  // LG1_DIR

	// Cg̏
	VSOutput.Light1_Dir_Gen = 0.0f ;

	// Cǧ̋txNgڒnԂɕϊ
	#ifdef BUMPMAP

		lLightTemp.x = dot( lViewTan, -lLightDir ) ;
		lLightTemp.y = dot( lViewBin, -lLightDir ) ;
		lLightTemp.z = dot( lViewNrm, -lLightDir ) ;
		VSOutput.Light1_Dir_Gen.xyz = normalize( lLightTemp ) ;

	#elif PHONG // BUMPMAP

		// Cǧ̋txNgۑ
		VSOutput.Light1_Dir_Gen.xyz = -lLightDir ;

	#endif // BUMPMAP

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( I )


	// EX|bgCglvZ ==========================( Jn )
	#if LG1_SPOT || LG1_POINT

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂ lLightTemp.x = ( POS - L1_POS ) * ( POS - L1_POS )
		lLightTemp = lViewPosition.xyz - g_Common.Light[ 1 ].Position ;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = 1.0f / ( g_Common.Light[ 1 ].Attenuation0 + g_Common.Light[ 1 ].Attenuation1 * sqrt( lLightDistancePow2 ) + g_Common.Light[ 1 ].Attenuation2 * lLightDistancePow2 ) ;

		// X|bgCgvZ --------

		#if LG1_SPOT

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, g_Common.Light[ 1 ].Direction.xyz ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - g_Common.Light[ 1 ].SpotParam0, 0.0f ) * g_Common.Light[ 1 ].SpotParam1 ), g_Common.Light[ 1 ].FallOff ) ) ;

		#endif // LG1_SPOT

		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, g_Common.Light[ 1 ].RangePow2 ) ;

		// ov}bv or tHVF[fBOpɌۑ
		#if PHONG || BUMPMAP
			VSOutput.Light1_Dir_Gen.w = lLightGen ;
		#endif // PHONG || BUMPMAP

	#endif // LG1_SPOT || LG1_POINT
	// EX|bgCglvZ =========================( I )




	// fBt[YCgƃXyLCg̊pxvZ =======( Jn )
	#if BUMPMAP == 0 && PHONG == 0

		// @ƃCg̋txNgƂ̓ς lLightLitParam.x ɃZbg
		lLightLitParam.x = dot( lViewNrm, -lLightDir ) ;

		#ifdef USE_SPE

			// n[txNǧvZ norm( ( norm( _ʒu王_ւ̃xNg ) + Cg̕ ) )
			lLightHalfVec = normalize( normalize( -lViewPosition.xyz ) - lLightDir ) ;

			// @ƃn[txNg̓ς lLightLitParam.y ɃZbg
			lLightLitParam.y = dot( lLightHalfVec, lViewNrm ) ;

			// XyL˗ lLightLitParam.w ɃZbg
			lLightLitParam.w = g_Common.Material.Power ;

			// CgvZ
			lLightLitDest = lit( lLightLitParam.x, lLightLitParam.y, lLightLitParam.w ) ;

		#else // USE_SPE

			lLightLitDest.y = max( lLightLitParam.x, 0.0f ) ;

		#endif // USE_SPE

	#endif // BUMPMAP == 0 && PHONG == 0
	// fBt[YCgƃXyLCg̊pxvZ =======( I )





	// fBt[YJ[vZ =======================================( Jn )

	#if BUMPMAP == 0 && PHONG == 0

		#if LG1_SPOT || LG1_POINT

			// fBt[YCg~ϒl += EX|bgCgpxl * ( fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z )
			lTotalDiffuse.xyz += lLightGen * ( lLightLitDest.y * g_Common.Light[ 1 ].Diffuse * lDifColor.xyz + g_Common.Light[ 1 ].Ambient.xyz ) ;

		#else  // LG1_SPOT || LG1_POINT

			// fBt[YCg~ϒl += fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z
			lTotalDiffuse.xyz += lLightLitDest.y * g_Common.Light[ 1 ].Diffuse * lDifColor.xyz + g_Common.Light[ 1 ].Ambient.xyz ;

		#endif // LG1_SPOT || LG1_POINT

	#endif // BUMPMAP == 0 && PHONG == 0

	// fBt[YJ[vZ =======================================( I )





	// XyLJ[vZ =======================================( Jn )

	#ifdef USE_SPE

		#if BUMPMAP == 0 && PHONG == 0

			#if LG1_SPOT || LG1_POINT

				// XyLCg~ϒl += XyLpxvZ * EX|bgCg * Cg̃XyLJ[
				lTotalSpecular.xyz += lLightGen * lLightLitDest.z * g_Common.Light[ 1 ].Specular ;

			#else	// LG1_SPOT || LG1_POINT

				// XyLCg~ϒl += XyLpxvZ * Cg̃XyLJ[
				lTotalSpecular.xyz += lLightLitDest.z * g_Common.Light[ 1 ].Specular ;

			#endif	// LG1_SPOT || LG1_POINT

		#endif // BUMPMAP == 0 && PHONG == 0

	#endif // USE_SPE

	// XyLJ[vZ =======================================( I )




#endif  // LG1_USE
// Cg1̏ ***********************************************************************************************************************************( I )








		// Cg2̏ ***********************************************************************************************************************************( Jn )
#if LG2_USE

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( Jn )

	#if LG2_DIR

		// Cg̕vZ
		lLightDir = g_Common.Light[ 2 ].Direction ;

	#else  // LG2_DIR

		// CgxNǧvZ
		lLightDir = normalize( lViewPosition.xyz - g_Common.Light[ 2 ].Position ) ;

	#endif  // LG2_DIR

	// Cg̏
	VSOutput.Light2_Dir_Gen = 0.0f ;

	// Cǧ̋txNgڒnԂɕϊ
	#ifdef BUMPMAP

		lLightTemp.x = dot( lViewTan, -lLightDir ) ;
		lLightTemp.y = dot( lViewBin, -lLightDir ) ;
		lLightTemp.z = dot( lViewNrm, -lLightDir ) ;
		VSOutput.Light2_Dir_Gen.xyz = normalize( lLightTemp ) ;

	#elif PHONG // BUMPMAP

		// Cǧ̋txNgۑ
		VSOutput.Light2_Dir_Gen.xyz = -lLightDir ;

	#endif // BUMPMAP

	// fBt[YJ[pxvZp̃Cg̕OvZ ======( I )


	// EX|bgCglvZ ==========================( Jn )
	#if LG2_SPOT || LG2_POINT

		// vZ ------------------

		// _ƃCgʒuƂ̋̓߂ lLightTemp.x = ( POS - L2_POS ) * ( POS - L2_POS )
		lLightTemp = lViewPosition.xyz - g_Common.Light[ 2 ].Position ;
		lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

		// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
		lLightGen = 1.0f / ( g_Common.Light[ 2 ].Attenuation0 + g_Common.Light[ 2 ].Attenuation1 * sqrt( lLightDistancePow2 ) + g_Common.Light[ 2 ].Attenuation2 * lLightDistancePow2 ) ;

		// X|bgCgvZ --------

		#if LG2_SPOT

			// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
			lLightDirectionCosA = dot( lLightDir, g_Common.Light[ 2 ].Direction.xyz ) ;

			// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
			lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - g_Common.Light[ 2 ].SpotParam0, 0.0f ) * g_Common.Light[ 2 ].SpotParam1 ), g_Common.Light[ 2 ].FallOff ) ) ;

		#endif // LG2_SPOT

		// LO猸őɂ鏈
		lLightGen *= step( lLightDistancePow2, g_Common.Light[ 2 ].RangePow2 ) ;

		// ov}bv or tHVF[fBOpɌۑ
		#if PHONG || BUMPMAP
			VSOutput.Light2_Dir_Gen.w = lLightGen ;
		#endif // PHONG || BUMPMAP

	#endif // LG2_SPOT || LG2_POINT
	// EX|bgCglvZ =========================( I )




	// fBt[YCgƃXyLCg̊pxvZ =======( Jn )
	#if BUMPMAP == 0 && PHONG == 0

		// @ƃCg̋txNgƂ̓ς lLightLitParam.x ɃZbg
		lLightLitParam.x = dot( lViewNrm, -lLightDir ) ;

		#ifdef USE_SPE

			// n[txNǧvZ norm( ( norm( _ʒu王_ւ̃xNg ) + Cg̕ ) )
			lLightHalfVec = normalize( normalize( -lViewPosition.xyz ) - lLightDir ) ;

			// @ƃn[txNg̓ς lLightLitParam.y ɃZbg
			lLightLitParam.y = dot( lLightHalfVec, lViewNrm ) ;

			// XyL˗ lLightLitParam.w ɃZbg
			lLightLitParam.w = g_Common.Material.Power ;

			// CgvZ
			lLightLitDest = lit( lLightLitParam.x, lLightLitParam.y, lLightLitParam.w ) ;

		#else // USE_SPE

			lLightLitDest.y = max( lLightLitParam.x, 0.0f ) ;

		#endif // USE_SPE

	#endif // BUMPMAP == 0 && PHONG == 0
	// fBt[YCgƃXyLCg̊pxvZ =======( I )





	// fBt[YJ[vZ =======================================( Jn )

	#if BUMPMAP == 0 && PHONG == 0

		#if LG2_SPOT || LG2_POINT

			// fBt[YCg~ϒl += EX|bgCgpxl * ( fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z )
			lTotalDiffuse.xyz += lLightGen * ( lLightLitDest.y * g_Common.Light[ 2 ].Diffuse * lDifColor.xyz + g_Common.Light[ 2 ].Ambient.xyz ) ;

		#else  // LG2_SPOT || LG2_POINT

			// fBt[YCg~ϒl += fBt[YpxvZ * fBt[YJ[ * Cg̃fBt[YJ[ + Cg̃ArGgJ[ƃ}eÃArGgJ[Z
			lTotalDiffuse.xyz += lLightLitDest.y * g_Common.Light[ 2 ].Diffuse * lDifColor.xyz + g_Common.Light[ 2 ].Ambient.xyz ;

		#endif // LG2_SPOT || LG2_POINT

	#endif // BUMPMAP == 0 && PHONG == 0

	// fBt[YJ[vZ =======================================( I )





	// XyLJ[vZ =======================================( Jn )

	#ifdef USE_SPE

		#if BUMPMAP == 0 && PHONG == 0

			#if LG2_SPOT || LG2_POINT

				// XyLCg~ϒl += XyLpxvZ * EX|bgCg * Cg̃XyLJ[
				lTotalSpecular.xyz += lLightGen * lLightLitDest.z * g_Common.Light[ 2 ].Specular ;

			#else	// LG2_SPOT || LG2_POINT

				// XyLCg~ϒl += XyLpxvZ * Cg̃XyLJ[
				lTotalSpecular.xyz += lLightLitDest.z * g_Common.Light[ 2 ].Specular ;

			#endif	// LG2_SPOT || LG2_POINT

		#endif // BUMPMAP == 0 && PHONG == 0

	#endif // USE_SPE

	// XyLJ[vZ =======================================( I )




#endif  // LG2_USE
// Cg2̏ ***********************************************************************************************************************************( I )















		// SẴfBt[Yvf킹ďo̓WX^ɃZbg =====( Jn )

		#if BUMPMAP == 0 && PHONG == 0

			// o̓fBt[YJ[ = CgfBt[YJ[~ϒl + ( }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z )
			VSOutput.Diffuse = lTotalDiffuse + g_Common.Material.Ambient_Emissive ;

			// At@̓fBt[YJ[̃At@̂܂܎g
			VSOutput.Diffuse.w = lDifColor.w ;

		#endif // BUMPMAP == 0 && PHONG == 0

		// SẴfBt[Yvf킹ďo̓WX^ɃZbg =====( I )





		// SẴXyLvf킹ďo̓WX^ɃZbg =====( Jn )

		#if USE_SPE && BUMPMAP == 0 && PHONG == 0

			// o̓XyLJ[ = CgXyLJ[~ϒl * XyLJ[
			VSOutput.Specular = lTotalSpecular * lSpeColor ;

		#endif // USE_SPE && BUMPMAP == 0 && PHONG == 0

		// SẴXyLvf킹ďo̓WX^ɃZbg =====( I )






	#endif // LG_USE
	// Cg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )















	// tHOvZ =============================================( Jn )

	#if FOG_LINEAR || FOG_EXP || FOG_EXP2

		#ifdef FOG_LINEAR

			// `tHOvZ
			FOG_OUT = lViewPosition.z * g_Common.Fog.LinearDiv + g_Common.Fog.LinearAdd ;

		#endif

		#ifdef FOG_EXP

			// wtHOvZ 1.0f / pow( e,  * density )
			FOG_OUT = 1.0f / pow( abs( g_Common.Fog.E ), lViewPosition.z * g_Common.Fog.Density ) ;

		#endif

		#ifdef FOG_EXP2

			// wtHOQvZ 1.0f / pow( e, (  * density ) * (  * density ) )
			FOG_OUT = 1.0f / pow( abs( g_Common.Fog.E ), ( lViewPosition.z * g_Common.Fog.Density ) * ( lViewPosition.z * g_Common.Fog.Density ) ) ;

		#endif

	#endif // FOG_LINEAR || FOG_EXP || FOG_EXP2

	// tHOvZ =============================================( I )

#if SHADOWMAP_DRAW
	// ˉeWeNX`WƂďo͂ =================( Jn )

	VSOutput.ShadowMap0Pos = VSOutput.Position.xyz ;

	// ˉeWeNX`WƂďo͂ =================( I )
#endif


#if SHADOWMAP
	// [xep̃Cg猩ˉeWZo =================( Jn )

	// [hWVhE}bvÕCgݒ̎ˉeWɕϊ
	VSOutput.ShadowMap0Pos.x = dot( lWorldPosition, g_OtherMatrix.ShadowMapLightViewProjectionMatrix[ 0 ][ 0 ] ) ;
	VSOutput.ShadowMap0Pos.y = dot( lWorldPosition, g_OtherMatrix.ShadowMapLightViewProjectionMatrix[ 0 ][ 1 ] ) ;
	VSOutput.ShadowMap0Pos.z = dot( lWorldPosition, g_OtherMatrix.ShadowMapLightViewProjectionMatrix[ 0 ][ 2 ] ) ;

	// [hWVhE}bvP̃Cgݒ̎ˉeWɕϊ
	VSOutput.ShadowMap1Pos.x = dot( lWorldPosition, g_OtherMatrix.ShadowMapLightViewProjectionMatrix[ 1 ][ 0 ] ) ;
	VSOutput.ShadowMap1Pos.y = dot( lWorldPosition, g_OtherMatrix.ShadowMapLightViewProjectionMatrix[ 1 ][ 1 ] ) ;
	VSOutput.ShadowMap1Pos.z = dot( lWorldPosition, g_OtherMatrix.ShadowMapLightViewProjectionMatrix[ 1 ][ 2 ] ) ;

	// [hWVhE}bvQ̃Cgݒ̎ˉeWɕϊ
	VSOutput.ShadowMap2Pos.x = dot( lWorldPosition, g_OtherMatrix.ShadowMapLightViewProjectionMatrix[ 2 ][ 0 ] ) ;
	VSOutput.ShadowMap2Pos.y = dot( lWorldPosition, g_OtherMatrix.ShadowMapLightViewProjectionMatrix[ 2 ][ 1 ] ) ;
	VSOutput.ShadowMap2Pos.z = dot( lWorldPosition, g_OtherMatrix.ShadowMapLightViewProjectionMatrix[ 2 ][ 2 ] ) ;

	// [xep̃Cg猩ˉeWZo =================( I )
#endif

	// eNX`W̃Zbg
	VSOutput.TexCoords0_1.x = dot( VSInput.TexCoords0, g_OtherMatrix.TextureMatrix[ 0 ][ 0 ] ) ;
	VSOutput.TexCoords0_1.y = dot( VSInput.TexCoords0, g_OtherMatrix.TextureMatrix[ 0 ][ 1 ] ) ;

//#ifdef SUBTEXTURE
	VSOutput.TexCoords0_1.z = dot( VSInput.TexCoords1, g_OtherMatrix.TextureMatrix[ 0 ][ 0 ] ) ;
	VSOutput.TexCoords0_1.w = dot( VSInput.TexCoords1, g_OtherMatrix.TextureMatrix[ 0 ][ 1 ] ) ;
//#endif // SUBTEXTURE


	return VSOutput ;
}

